package com.moye.sdk;

import java.io.BufferedInputStream;
import java.io.ByteArrayInputStream;
import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.net.CookiePolicy;
import java.net.URI;
import java.nio.charset.Charset;
import java.util.List;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.HttpStatus;
import org.apache.http.NameValuePair;
import org.apache.http.client.CookieStore;
import org.apache.http.client.HttpClient;
import org.apache.http.client.entity.UrlEncodedFormEntity;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.params.ClientPNames;
import org.apache.http.entity.mime.HttpMultipartMode;
import org.apache.http.entity.mime.MultipartEntity;
import org.apache.http.entity.mime.content.ContentBody;
import org.apache.http.entity.mime.content.FileBody;
import org.apache.http.entity.mime.content.StringBody;
import org.apache.http.impl.client.DefaultHttpClient;

import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpConnectionParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HTTP;
import org.apache.http.util.EntityUtils;

import com.moye.bikeceo.common.BikeCeoApp;
import com.moye.bikeceo.common.CommonDefines;
import com.moye.bikeceo.common.MyGlobal;
import com.moye.bikeceo.common.MyUtil;

import android.content.Context;
import android.content.SharedPreferences;
import android.content.SharedPreferences.Editor;
//import android.os.StrictMode;
import android.graphics.Bitmap;
import android.graphics.BitmapFactory;
import android.util.DisplayMetrics;
import android.util.Log;

public class RequestAPI implements RequestAPIInter {
	// TODO SDKĬϲ
	public static final int CONNECTION_TIMEOUT = 5000;
	private DefaultHttpClient httpClient;

	// 2.0 add
	private static CookieStore cookieStore = null;
	private static final String URL_SET_VERSION = "http://www.bikeceo.cn/bikeapi/?m=api&a=set_api_version";// ð汾

	@Override
	public String httpget(String url) {
		String sUrl = url;
		// sUrl += "&v=2.0";
		// ӳʱʱݶȡʱʱ
		HttpParams httpParams = new BasicHttpParams();
		HttpConnectionParams.setConnectionTimeout(httpParams, 30000);
		HttpConnectionParams.setSoTimeout(httpParams, 30000);
		// ½HttpClient
		httpClient = new DefaultHttpClient(httpParams);
		// Cookie
		if (cookieStore != null) {
			httpClient.setCookieStore(cookieStore);
		}

		// httpClient.getParams().setParameter(ClientPNames.COOKIE_POLICY,
		// CookiePolicy.ACCEPT_ALL);
		HttpGet request = new HttpGet(sUrl);
		String responseData = null;
		try {

			HttpResponse response = httpClient.execute(request);
			if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
				responseData = EntityUtils.toString(response.getEntity());
				Log.d("sisosos", "http response get: url: " + url
						+ "data len : " + responseData.getBytes().length);
				// cookie
				if (url.equals(URL_SET_VERSION)
						&& !MyGlobal.isStringNull(responseData)
						&& responseData.equals("true")) {
					// ð汾ɹ,űcookie
					cookieStore = httpClient.getCookieStore();

				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			request.abort();
			shutdownConnection();
		}

		return responseData;
	}

	/**
	 * PostϢ
	 * 
	 * @param url
	 *            ӵURL
	 * @param
	 * @return صϢ
	 * @throws Exception
	 */
	public String httpPost(String url, List<NameValuePair> params)
			throws Exception {
		String sUrl = url;
		// sUrl += "&v=2.0";
		HttpParams httpParameters = new BasicHttpParams();
		HttpConnectionParams.setConnectionTimeout(httpParameters, 30000);
		HttpConnectionParams.setSoTimeout(httpParameters, 30000);
		httpClient = new DefaultHttpClient(httpParameters);

		// ȡcookie
		if (cookieStore != null) {
			httpClient.setCookieStore(cookieStore);
		}

		String responseData = null;
		HttpPost post = new HttpPost(sUrl);

		post.setEntity(new UrlEncodedFormEntity(params, HTTP.UTF_8));
		try {
			HttpResponse response = httpClient.execute(post);
			if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
				responseData = EntityUtils.toString(response.getEntity());
				Log.d("sisosos", "http response post: url: " + url + "data"
						+ responseData.getBytes().length);
				// cookie
				if (url.equals(URL_SET_VERSION)
						&& !MyGlobal.isStringNull(responseData)
						&& responseData.equals("true")) {
					// ð汾ɹ,űcookie
					cookieStore = httpClient.getCookieStore();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			post.abort();
			shutdownConnection();
		}
		return responseData;

	}

	/**
	 * PostļϢ
	 * 
	 * @param url
	 *            ӵURL
	 * @param imgFilePath
	 *            :Ҫϴļ· degree:ͼƬתĽǶ
	 * @param filePath
	 *            :Ҫϴļ·(ͼƬ),ļ··:·ļ:
	 *            /mnt/sdcard/BikeCeo/data/kml/test.kml
	 * @return صϢ
	 * @throws Exception
	 */
	public String httpPostWithFile(String url, List<NameValuePair> params,
			String picParams, String imgFilePath, String fParams,
			String filePath) throws Exception {
		String sUrl = url;
		// sUrl += "&v=2.0";
		// óʱ
		HttpParams httpParameters = new BasicHttpParams();
		HttpConnectionParams.setConnectionTimeout(httpParameters, 30000);
		HttpConnectionParams.setSoTimeout(httpParameters, 30000);
		httpClient = new DefaultHttpClient(httpParameters);
		// Cookie,ʱ俼prefesharecookie

		if (cookieStore != null) {
			httpClient.setCookieStore(cookieStore);
		}

		String responseData = null;
		StringBody stringBody;// 
		HttpPost post = new HttpPost(sUrl);

		MultipartEntity mpEntity = new MultipartEntity(
				HttpMultipartMode.BROWSER_COMPATIBLE);
		// @Ҫϴļ
		// 1.ͼƬļ
		if (imgFilePath != null && !imgFilePath.equals("")) {

			// ʱļѹϴͼƬ
			getimage(imgFilePath);
			File file = new File("/mnt/sdcard/BikeCeo/temp/temp_pic.jpg");
			Log.i("file", "" + file.length());
			ContentBody cbFile = new FileBody(file, "image/jpg");
			mpEntity.addPart(picParams, cbFile);
		}
		// 2.ļ,kml
		if (filePath != null && !filePath.equals("")) {
			File file = new File(filePath);
			if (file.exists()) {
				// ٴȷļǷ
				ContentBody cbFile = new FileBody(file);
				mpEntity.addPart(fParams, cbFile);
			}

		}
		// @Ҫϴı
		for (int index = 0; index < params.size(); index++) {
			stringBody = new StringBody(params.get(index).getValue(),
					Charset.forName("UTF-8"));
			mpEntity.addPart(params.get(index).getName(), stringBody);

		}
		post.setEntity(mpEntity);
		try {
			HttpResponse response = httpClient.execute(post);
			if (response.getStatusLine().getStatusCode() == HttpStatus.SC_OK) {
				responseData = EntityUtils.toString(response.getEntity());
				// cookie
				if (url.equals(URL_SET_VERSION)
						&& !MyGlobal.isStringNull(responseData)
						&& responseData.equals("true")) {
					// ð汾ɹ,űcookie
					cookieStore = httpClient.getCookieStore();
				}
			}
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
			post.abort();
			shutdownConnection();
		}
		return responseData;

	}

	/**
	 * ϿQHttpClient
	 */
	public void shutdownConnection() {
		try {
			if (httpClient != null)
				httpClient.getConnectionManager().shutdown();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}

	/**
	 * ͼƬСѹ·ȡͼƬѹ
	 */

	private void getimage(String srcPath) {
		Bitmap bmpCompress = getSmallBitmap(srcPath);
		if (bmpCompress != null) {
			put_inSdcard(bmpCompress);
			// compressImage(bmpCompress);
			bmpCompress.recycle();
			System.gc();
		}
	}

	public Bitmap getSmallBitmap(String filePath) {

		File file = new File(filePath);
		int bytes = (int) file.length();
		Bitmap bitmapCompress = null;
		InputStream is = null;

		try {
			is = new FileInputStream(filePath);
		} catch (FileNotFoundException e) {
			// TODO Auto-generated catch block
			e.printStackTrace();
		}
		try {
			final BitmapFactory.Options options = new BitmapFactory.Options();
			options.inJustDecodeBounds = true;
			BitmapFactory.decodeFile(filePath, options);

			// Calculate inSampleSize
			options.inSampleSize = calculateInSampleSize(options, bytes);
			options.inPreferredConfig = Bitmap.Config.RGB_565;
			// Decode bitmap with inSampleSize set
			options.inJustDecodeBounds = false;
			if (is != null) {
				bitmapCompress = BitmapFactory.decodeStream(is, null, options);
				// ͼƬǷҪת
				int degree = MyUtil.readPictureDegree(filePath);
				if (degree != 0 && degree != 1) {
					bitmapCompress = MyUtil.rotaingImageView(degree,
							bitmapCompress);
				}
				try {
					is.close();
					is = null;
				} catch (IOException e) {
					// TODO Auto-generated catch block
					is = null;
					e.printStackTrace();
				}
			}
		} catch (OutOfMemoryError e) {
			System.gc();// ֪ͨ
		}
		return bitmapCompress;
	}

	// ͼƬֵ
	public int calculateInSampleSize(BitmapFactory.Options options,
			int totalBytes) {
		final int height = options.outHeight;
		final int width = options.outWidth;
		// final Bitmap.Config config = options.inPreferredConfig;
		int inSampleSize = 1;

		// ʼ
		double reqWidth = width;
		double reqHeight = height;
		if (totalBytes > 90 * 1024) {
			// 90k ı
			double X = (double) totalBytes / (width * height);
			double radio = (double) height / width;
			reqWidth = Math.sqrt(120 * 1024 / radio);
			reqHeight = radio * reqWidth;
		}

		if (height > reqHeight || width > reqWidth) {
			final int heightRatio = (int) Math.ceil(height / reqHeight);
			final int widthRatio = (int) Math.ceil(width / reqWidth);
			inSampleSize = heightRatio > widthRatio ? heightRatio : widthRatio;
		}
		return inSampleSize;
	}

	/**
	 * sdCard
	 */
	public void put_inSdcard(Bitmap bitmap) {

		File file = new File("/mnt/sdcard/BikeCeo/temp");
		if (!file.exists()) {
			file.mkdirs();
		}
		File file2 = new File("/mnt/sdcard/BikeCeo/temp/" + "temp_pic.jpg");
		try {

			FileOutputStream out = new FileOutputStream(file2);
			if (bitmap.compress(Bitmap.CompressFormat.JPEG, 70, out)) {
				out.flush();
				out.close();
			}
		} catch (Exception e) {
			// TODO: handle exception
		}

	}
}
